## vulkan-tools 1.2.131.1+dfsg1

=== CMakeLists.txt ===
# ~~~
# Copyright (c) 2014-2018 Valve Corporation
# Copyright (c) 2014-2018 LunarG, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ~~~

# CMake project initialization ---------------------------------------------------------------------------------------------------
# This section contains pre-project() initialization, and ends with the project() command.

cmake_minimum_required(VERSION 3.10.2)

# Apple: Must be set before enable_language() or project() as it may influence configuration of the toolchain and flags.
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.12" CACHE STRING "Minimum OS X deployment version")

project(Vulkan-Tools)

# find_package(), include() and global project settings --------------------------------------------------------------------------

find_package(PythonInterp 3 QUIET)

# User-interface declarations ----------------------------------------------------------------------------------------------------
# This section contains variables that affect development GUIs (e.g. CMake GUI and IDEs), such as option(), folders, and variables
# with the CACHE property.

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

option(BUILD_CUBE "Build cube" ON)
option(BUILD_VULKANINFO "Build vulkaninfo" ON)
option(BUILD_ICD "Build icd" ON)
# Installing the Mock ICD to system directories is probably not desired since this ICD is not a very complete implementation.
# Require the user to ask that it be installed if they really want it.
option(INSTALL_ICD "Install icd" OFF)

# Enable IDE GUI folders
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
# "Helper" targets that don't have interesting source code should set their FOLDER property to this
set(TOOLS_HELPER_FOLDER "Helper Targets")

option(USE_CCACHE "Use ccache" OFF)
if(USE_CCACHE)
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    endif()
endif()

# ~~~
# Find Vulkan Headers and Loader
# Search order:
#  User-supplied CMAKE_PREFIX_PATH containing paths to the header and/or loader install dirs
#  CMake options VULKAN_HEADERS_INSTALL_DIR and/or VULKAN_LOADER_INSTALL_DIR
#  Env vars VULKAN_HEADERS_INSTALL_DIR and/or VULKAN_LOADER_INSTALL_DIR
#  If on MacOS
#   CMake option MOTLENVK_REPO_ROOT
#   Env vars MOLTENVK_REPO_ROOT
#  Fallback to FindVulkan operation using SDK install or system installed components.
# ~~~
set(VULKAN_HEADERS_INSTALL_DIR "HEADERS-NOTFOUND" CACHE PATH "Absolute path to a Vulkan-Headers install directory")
set(VULKAN_LOADER_INSTALL_DIR "LOADER-NOTFOUND" CACHE PATH "Absolute path to a Vulkan-Loader install directory")
if(WIN32 AND "${VULKAN_LOADER_INSTALL_DIR}" STREQUAL "LOADER-NOTFOUND")
    if(CMAKE_CL_64)
        set(VULKAN_LOADER_INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/external/x64")
    else()
        set(VULKAN_LOADER_INSTALL_DIR "${CMAKE_CURRENT_SOURCE_DIR}/external/x86")
    endif()
endif()
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH};${VULKAN_HEADERS_INSTALL_DIR};${VULKAN_LOADER_INSTALL_DIR};
    $ENV{VULKAN_HEADERS_INSTALL_DIR};$ENV{VULKAN_LOADER_INSTALL_DIR})

if(APPLE)
    set(MOLTENVK_REPO_ROOT "MOLTENVK-NOTFOUND" CACHE PATH "Absolute path to a MoltenVK repo directory")
    if(NOT MOLTENVK_REPO_ROOT AND NOT DEFINED ENV{MOLTENVK_REPO_ROOT})
        message(FATAL_ERROR "Must define location of MoltenVK repo -- see BUILD.md")
    endif()

    if(NOT MOLTENVK_REPO_ROOT)
        set(MOLTENVK_REPO_ROOT $ENV{MOLTENVK_REPO_ROOT})
    endif()
    message(STATUS "Using MoltenVK repo location at ${MOLTENVK_REPO_ROOT}")
endif()
message(STATUS "Using find_package to locate Vulkan")
find_package(Vulkan)
find_package(VulkanHeaders)
get_filename_component(Vulkan_LIBRARY_DIR ${Vulkan_LIBRARY} DIRECTORY)
message(STATUS "Vulkan FOUND = ${Vulkan_FOUND}")
message(STATUS "Vulkan Lib Dir = ${Vulkan_LIBRARY_DIR}")
message(STATUS "Vulkan Lib = ${Vulkan_LIBRARY}")
message(STATUS "Vulkan Headers Include = ${VulkanHeaders_INCLUDE_DIR}")
message(STATUS "Vulkan Headers Registry = ${VulkanRegistry_DIR}")

include(GNUInstallDirs)

if(WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    # Windows: if install locations not set by user, set install prefix to "<build_dir>\install".
    set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "default install path" FORCE)
endif()

# uninstall target
if(NOT TARGET uninstall)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
                   IMMEDIATE
                   @ONLY)

    add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
    set_target_properties(uninstall PROPERTIES FOLDER ${TOOLS_HELPER_FOLDER})
endif()

if(APPLE)
    # CMake versions 3 or later need CMAKE_MACOSX_RPATH defined. This avoids the CMP0042 policy message.
    set(CMAKE_MACOSX_RPATH 1)
endif()

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    set(COMMON_COMPILE_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
    set(COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -fno-strict-aliasing -fno-builtin-memcmp")

    # For GCC version 7.1 or greater, we need to disable the implicit fallthrough warning since there's no consistent way to satisfy
    # all compilers until they all accept the C++17 standard
    if(CMAKE_COMPILER_IS_GNUCC AND NOT (CMAKE_CXX_COMPILER_VERSION LESS 7.1))
        set(COMMON_COMPILE_FLAGS "${COMMON_COMPILE_FLAGS} -Wimplicit-fallthrough=0")
    endif()

    if(APPLE)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${COMMON_COMPILE_FLAGS}")
    else()
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 ${COMMON_COMPILE_FLAGS}")
    endif()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${COMMON_COMPILE_FLAGS} -std=c++11 -fno-rtti")
    if(UNIX)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
    endif()
endif()

# Optional codegen target
if(PYTHONINTERP_FOUND)
    add_custom_target(VulkanTools_generated_source
                      COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/scripts/generate_source.py
                              ${VulkanRegistry_DIR} --incremental
                      )
else()
    message("WARNING: VulkanTools_generated_source target requires python 3")
endif()

if(APPLE)
    include(mac_common.cmake)
endif()

if(BUILD_CUBE)
    add_subdirectory(cube)
endif()

if(BUILD_VULKANINFO)
    add_subdirectory(vulkaninfo)
endif()

if(BUILD_ICD)
    add_subdirectory(icd)
endif()

=== cube/CMakeLists.txt ===
# ~~~
# Copyright (c) 2018 Valve Corporation
# Copyright (c) 2018 LunarG, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ~~~

set(CUBE_INCLUDE_DIRS ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/.. ${VulkanHeaders_INCLUDE_DIR})

set(SCRIPTS_DIR "${PROJECT_SOURCE_DIR}/scripts")

if (NOT GLSLANG_INSTALL_DIR AND DEFINED ENV{GLSLANG_INSTALL_DIR})
    set(GLSLANG_INSTALL_DIR $ENV{GLSLANG_INSTALL_DIR})
endif()

if(GLSLANG_INSTALL_DIR)
    message(STATUS "Using GLSLANG_INSTALL_DIR to look for glslangValidator")
    find_program(GLSLANG_VALIDATOR names glslangValidator HINTS "${GLSLANG_INSTALL_DIR}/bin")
else()
    set(GLSLANG_VALIDATOR_NAME "glslangValidator")
    message(STATUS "Using cmake find_program to look for glslangValidator")
    if(WIN32)
        execute_process(
            COMMAND ${PYTHON_EXECUTABLE} ${SCRIPTS_DIR}/fetch_glslangvalidator.py glslang-master-windows-x64-Release.zip)
        set(GLSLANG_VALIDATOR_NAME "glslangValidator.exe")
    elseif(APPLE)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} ${SCRIPTS_DIR}/fetch_glslangvalidator.py glslang-master-osx-Release.zip)
    elseif(UNIX AND NOT APPLE) # i.e. Linux
        execute_process(COMMAND ${PYTHON_EXECUTABLE} ${SCRIPTS_DIR}/fetch_glslangvalidator.py glslang-master-linux-Release.zip)
    endif()
    find_program(GLSLANG_VALIDATOR NAMES ${GLSLANG_VALIDATOR_NAME} HINTS "${PROJECT_SOURCE_DIR}/glslang/bin")
endif()

if(UNIX AND NOT APPLE) # i.e. Linux
    include(FindPkgConfig)
    option(BUILD_WSI_XCB_SUPPORT "Build XCB WSI support" ON)
    option(BUILD_WSI_XLIB_SUPPORT "Build Xlib WSI support" ON)
    option(BUILD_WSI_WAYLAND_SUPPORT "Build Wayland WSI support" ON)
    set(CUBE_WSI_SELECTION "XCB" CACHE STRING "Select WSI target for vkcube (XCB, XLIB, WAYLAND, DISPLAY)")

    if(BUILD_WSI_XCB_SUPPORT)
        find_package(XCB REQUIRED)
    endif()

    if(BUILD_WSI_XLIB_SUPPORT)
        find_package(X11 REQUIRED)
    endif()

    if(BUILD_WSI_WAYLAND_SUPPORT)
        find_package(Wayland REQUIRED)
        include_directories(${WAYLAND_CLIENT_INCLUDE_DIR})
    endif()
endif()

if(WIN32)
    add_definitions(-DVK_USE_PLATFORM_WIN32_KHR -DWIN32_LEAN_AND_MEAN)
    if(NOT MSVC_VERSION LESS 1900)
        # Enable control flow guard
        message(STATUS "Building vkcube with control flow guard")
        add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/guard:cf>")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /guard:cf")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /guard:cf")
    endif()
elseif(ANDROID)
    add_definitions(-DVK_USE_PLATFORM_ANDROID_KHR)
elseif(APPLE)
    add_definitions(-DVK_USE_PLATFORM_METAL_EXT)
elseif(UNIX AND NOT APPLE) # i.e. Linux
    if(NOT CUBE_WSI_SELECTION)
        set(CUBE_WSI_SELECTION "XCB")
    endif()

    if(CUBE_WSI_SELECTION STREQUAL "XCB")
        if(NOT BUILD_WSI_XCB_SUPPORT)
            message(FATAL_ERROR "Selected XCB for vkcube build but not building Xcb support")
        endif()
        set(CUBE_INCLUDE_DIRS ${XCB_INCLUDE_DIRS} ${CUBE_INCLUDE_DIRS})
        link_libraries(${XCB_LIBRARIES})
        add_definitions(-DVK_USE_PLATFORM_XCB_KHR)
    elseif(CUBE_WSI_SELECTION STREQUAL "XLIB")
        if(NOT BUILD_WSI_XLIB_SUPPORT)
            message(FATAL_ERROR "Selected XLIB for vkcube build but not building Xlib support")
        endif()
        set(CUBE_INCLUDE_DIRS ${X11_INCLUDE_DIR} ${CUBE_INCLUDE_DIRS})
        link_libraries(${X11_LIBRARIES})
        add_definitions(-DVK_USE_PLATFORM_XLIB_KHR)
    elseif(CUBE_WSI_SELECTION STREQUAL "WAYLAND")
        if(NOT BUILD_WSI_WAYLAND_SUPPORT)
            message(FATAL_ERROR "Selected Wayland for vkcube build but not building Wayland support")
        endif()
        set(CUBE_INCLUDE_DIRS ${WAYLAND_CLIENT_INCLUDE_DIR} ${CUBE_INCLUDE_DIRS})
        link_libraries(${WAYLAND_CLIENT_LIBRARIES})
        add_definitions(-DVK_USE_PLATFORM_WAYLAND_KHR)
    elseif(CUBE_WSI_SELECTION STREQUAL "DISPLAY")
        add_definitions(-DVK_USE_PLATFORM_DISPLAY_KHR)
    else()
        message(FATAL_ERROR "Unrecognized value for CUBE_WSI_SELECTION: ${CUBE_WSI_SELECTION}")
    endif()

    link_libraries(${API_LOWERCASE} m)
else()
    message(FATAL_ERROR "Unsupported Platform!")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

if(WIN32)
    # Use static MSVCRT libraries
    foreach(configuration
            in
            CMAKE_C_FLAGS_DEBUG
            CMAKE_C_FLAGS_MINSIZEREL
            CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS_DEBUG
            CMAKE_CXX_FLAGS_MINSIZEREL
            CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_RELWITHDEBINFO)
        if(${configuration} MATCHES "/MD")
            string(REGEX
                   REPLACE "/MD"
                           "/MT"
                           ${configuration}
                           "${${configuration}}")
        endif()
    endforeach()

    file(COPY cube.vcxproj.user DESTINATION ${CMAKE_BINARY_DIR}/cube)
endif()

add_custom_command(COMMENT "Compiling cube vertex shader"
                   OUTPUT cube.vert.inc
                   COMMAND ${GLSLANG_VALIDATOR} -V -x -o ${CMAKE_CURRENT_BINARY_DIR}/cube.vert.inc
                           ${PROJECT_SOURCE_DIR}/cube/cube.vert
                   MAIN_DEPENDENCY ${PROJECT_SOURCE_DIR}/cube/cube.vert
                   DEPENDS ${PROJECT_SOURCE_DIR}/cube/cube.vert ${GLSLANG_VALIDATOR})
add_custom_command(COMMENT "Compiling cube fragment shader"
                   OUTPUT cube.frag.inc
                   COMMAND ${GLSLANG_VALIDATOR} -V -x -o ${CMAKE_CURRENT_BINARY_DIR}/cube.frag.inc
                           ${PROJECT_SOURCE_DIR}/cube/cube.frag
                   MAIN_DEPENDENCY ${PROJECT_SOURCE_DIR}/cube/cube.frag
                   DEPENDS ${PROJECT_SOURCE_DIR}/cube/cube.frag ${GLSLANG_VALIDATOR})
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

if(WIN32)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_WARNINGS -D_USE_MATH_DEFINES")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_CRT_SECURE_NO_WARNINGS -D_USE_MATH_DEFINES")
endif()

include_directories(${CUBE_INCLUDE_DIRS})

# ----------------------------------------------------------------------------
# vkcube

if(APPLE)
    include(macOS/cube/cube.cmake)
elseif(NOT WIN32)
    if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL ${CMAKE_HOST_SYSTEM_PROCESSOR})
        add_executable(vkcube
                       cube.c
                       ${PROJECT_SOURCE_DIR}/cube/cube.vert
                       ${PROJECT_SOURCE_DIR}/cube/cube.frag
                       cube.vert.inc
                       cube.frag.inc)
        target_link_libraries(vkcube Vulkan::Vulkan)
        CHECK_LIBRARY_EXISTS("rt" clock_gettime "" NEED_RT)
        if (NEED_RT)
            target_link_libraries(vkcube rt)
        endif()
    endif()
else()
    if(CMAKE_CL_64)
        set(LIB_DIR "Win64")
    else()
        set(LIB_DIR "Win32")
    endif()

    add_executable(vkcube
                   WIN32
                   cube.c
                   ${PROJECT_SOURCE_DIR}/cube/cube.vert
                   ${PROJECT_SOURCE_DIR}/cube/cube.frag
                   cube.vert.inc
                   cube.frag.inc)
    target_link_libraries(vkcube Vulkan::Vulkan)
endif()

if(APPLE)
    # Keep RPATH so fixup_bundle can use it to find libraries
    set_target_properties(vkcube PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
    install(TARGETS vkcube BUNDLE DESTINATION "cube")
    # Fix up the library references to be self-contained within the bundle.
    install(CODE "
        include(BundleUtilities)
        fixup_bundle(\${CMAKE_INSTALL_PREFIX}/cube/vkcube.app \"\" \"${Vulkan_LIBRARY_DIR}\")
        ")
else()
    install(TARGETS vkcube RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

# ----------------------------------------------------------------------------
# vkcubepp

if(APPLE)
    include(macOS/cubepp/cubepp.cmake)
elseif(NOT WIN32)
    if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL ${CMAKE_HOST_SYSTEM_PROCESSOR})
        add_executable(vkcubepp
                       cube.cpp
                       ${PROJECT_SOURCE_DIR}/cube/cube.vert
                       ${PROJECT_SOURCE_DIR}/cube/cube.frag
                       cube.vert.inc
                       cube.frag.inc)
        target_link_libraries(vkcubepp Vulkan::Vulkan)
    endif()
else()
    if(CMAKE_CL_64)
        set(LIB_DIR "Win64")
    else()
        set(LIB_DIR "Win32")
    endif()

    add_executable(vkcubepp
                   WIN32
                   cube.cpp
                   ${PROJECT_SOURCE_DIR}/cube/cube.vert
                   ${PROJECT_SOURCE_DIR}/cube/cube.frag
                   cube.vert.inc
                   cube.frag.inc)
    target_link_libraries(vkcubepp Vulkan::Vulkan)
endif()

if(APPLE)
    # Keep RPATH so fixup_bundle can use it to find libraries
    set_target_properties(vkcubepp PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
    install(TARGETS vkcubepp BUNDLE DESTINATION "cube")
    # Fix up the library references to be self-contained within the bundle.
    install(CODE "
        include(BundleUtilities)
        fixup_bundle(\${CMAKE_INSTALL_PREFIX}/cube/vkcubepp.app \"\" \"${Vulkan_LIBRARY_DIR}\")
        ")
else()
    install(TARGETS vkcubepp RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== vulkaninfo/CMakeLists.txt ===
# ~~~
# Copyright (c) 2018-2019 Valve Corporation
# Copyright (c) 2018-2019 LunarG, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ~~~

# CMakeLists.txt file for building Vulkaninfo

find_package(PythonInterp 3 QUIET)
set (PYTHON_CMD ${PYTHON_EXECUTABLE})

set(VKINFO_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(KVULKANTOOLS_SCRIPTS_DIR ${CMAKE_SOURCE_DIR}/scripts)

if(PYTHONINTERP_FOUND)
    add_custom_target(generate_vulkaninfo_hpp
        COMMAND ${PYTHON_CMD} ${KVULKANTOOLS_SCRIPTS_DIR}/kvt_genvk.py -registry ${VulkanRegistry_DIR}/vk.xml -scripts ${VulkanRegistry_DIR} vulkaninfo.hpp
        DEPENDS ${VulkanRegistry_DIR}/vk.xml ${VulkanRegistry_DIR}/generator.py ${KVULKANTOOLS_SCRIPTS_DIR}/vulkaninfo_generator.py ${KVULKANTOOLS_SCRIPTS_DIR}/kvt_genvk.py ${VulkanRegistry_DIR}/reg.py
        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/vulkaninfo/generated
        )
    else()
        message("WARNING: generate_vulkaninfo_hpp target requires python 3")
endif()

if(WIN32)
    add_executable(vulkaninfo vulkaninfo.cpp vulkaninfo.rc)
elseif(APPLE)
    add_executable(vulkaninfo
                   vulkaninfo.cpp
                   ${CMAKE_CURRENT_SOURCE_DIR}/macOS/vulkaninfo/metal_view.mm
                   ${CMAKE_CURRENT_SOURCE_DIR}/macOS/vulkaninfo/metal_view.h)
else()
    add_executable(vulkaninfo vulkaninfo.cpp)
endif()

target_include_directories(vulkaninfo PRIVATE ${CMAKE_SOURCE_DIR}/vulkaninfo)
target_include_directories(vulkaninfo PRIVATE ${CMAKE_SOURCE_DIR}/vulkaninfo/generated)

if(UNIX AND NOT APPLE) # i.e. Linux
    include(FindPkgConfig)
    option(BUILD_WSI_XCB_SUPPORT "Build XCB WSI support" ON)
    option(BUILD_WSI_XLIB_SUPPORT "Build Xlib WSI support" ON)
    option(BUILD_WSI_WAYLAND_SUPPORT "Build Wayland WSI support" ON)

    if(BUILD_WSI_XCB_SUPPORT)
        find_package(XCB REQUIRED)
        target_include_directories(vulkaninfo PRIVATE ${XCB_INCLUDE_DIRS})
        target_link_libraries(vulkaninfo ${XCB_LIBRARIES})
        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_XCB_KHR)
    endif()

    if(BUILD_WSI_XLIB_SUPPORT)
        find_package(X11 REQUIRED)
        target_include_directories(vulkaninfo PRIVATE ${X11_INCLUDE_DIR})
        target_link_libraries(vulkaninfo ${X11_LIBRARIES})
        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_XLIB_KHR)
    endif()

    if(BUILD_WSI_WAYLAND_SUPPORT)
        find_package(Wayland REQUIRED)
        target_include_directories(vulkaninfo PRIVATE ${WAYLAND_CLIENT_INCLUDE_DIR})
        target_link_libraries(vulkaninfo ${WAYLAND_CLIENT_LIBRARIES})
        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_WAYLAND_KHR)
    endif()
endif()

if(APPLE)
    # We do this so vulkaninfo is linked to an individual library and NOT a framework.
    target_link_libraries(vulkaninfo ${Vulkan_LIBRARY} "-framework AppKit -framework QuartzCore")
    target_include_directories(vulkaninfo PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/macOS/vulkaninfo ${VulkanHeaders_INCLUDE_DIR})
else()
    target_link_libraries(vulkaninfo Vulkan::Vulkan)
endif()

# Create vulkaninfo application bundle for MacOS
if(APPLE)
    include(${CMAKE_CURRENT_SOURCE_DIR}/macOS/vulkaninfo.cmake)
endif()

if(WIN32)
    target_compile_definitions(vulkaninfo PUBLIC -DVK_USE_PLATFORM_WIN32_KHR -DWIN32_LEAN_AND_MEAN -D_CRT_SECURE_NO_WARNINGS)
    if(NOT MSVC_VERSION LESS 1900)
        # Enable control flow guard
        message(STATUS "Building vulkaninfo with control flow guard")
        add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/guard:cf>")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /guard:cf")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /guard:cf")
    endif()

    # Use static MSVCRT libraries
    foreach(configuration
            in
            CMAKE_C_FLAGS_DEBUG
            CMAKE_C_FLAGS_MINSIZEREL
            CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS_DEBUG
            CMAKE_CXX_FLAGS_MINSIZEREL
            CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_RELWITHDEBINFO)
        if(${configuration} MATCHES "/MD")
            string(REGEX
                   REPLACE "/MD"
                           "/MT"
                           ${configuration}
                           "${${configuration}}")
        endif()
    endforeach()

    file(COPY vulkaninfo.vcxproj.user DESTINATION ${CMAKE_BINARY_DIR}/vulkaninfo)
elseif(APPLE)
    add_definitions(-DVK_USE_PLATFORM_MACOS_MVK -DVK_USE_PLATFORM_METAL_EXT)
endif()

if(APPLE)
    install(TARGETS vulkaninfo RUNTIME DESTINATION "vulkaninfo")
else()
    install(TARGETS vulkaninfo RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

## vulkan-tools 1.1.82.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.1.82.0+dfsg1-0ubuntu2) cosmic; urgency=medium

  * Fix versioned Breaks/Replaces from vulkan-tools to vulkan-utils.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 14 Oct 2018 12:11:04 -0600

vulkan-tools (1.1.82.0+dfsg1-0ubuntu1) cosmic; urgency=medium

  * Sync from Debian.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 21 Sep 2018 14:45:41 +0300

vulkan-tools (1.1.82.0+dfsg1-1) experimental; urgency=medium

  * Initial upload, split from old src:vulkan.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 21 Sep 2018 14:32:33 +0300

=== debian/control ===
Source: vulkan-tools
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Build-Depends: debhelper (>= 11),
 cmake,
 glslang-tools,
 libvulkan-dev (>= 1.1.82.0),
 libwayland-dev,
 libx11-dev,
 libxcb1-dev,
 libxrandr-dev,
 python3,
Standards-Version: 4.2.0
Section: libs
Homepage: https://github.com/KhronosGroup/Vulkan-Tools
Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/vulkan-tools.git
Vcs-Browser: https://salsa.debian.org/xorg-team/vulkan/vulkan-tools

Package: vulkan-tools
Architecture: linux-any
Section: graphics
Depends: ${shlibs:Depends}, ${misc:Depends},
 libvulkan1,
Breaks: vulkan-sdk-runtime,
 vulkan-utils (<< 1.1.82.0+dfsg1-0ubuntu1),
Replaces: vulkan-sdk-runtime,
 vulkan-utils (<< 1.1.82.0+dfsg1-0ubuntu1),
Provides:
 vulkan-utils,
Description: Miscellaneous Vulkan utilities
 This package provides utilities for Vulkan, including vulkaninfo.

Package: vulkan-utils
Architecture: all
Priority: optional
Section: oldlibs
Depends: vulkan-tools, ${misc:Depends}
Description: transitional package
  This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --builddirectory=build/

override_dh_auto_configure:
	dh_auto_configure -- \
	-DGLSLANG_INSTALL_DIR=/usr/bin

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

	mv debian/tmp/usr/bin/cube debian/tmp/usr/bin/vulkan-cube
	mv debian/tmp/usr/bin/cubepp debian/tmp/usr/bin/vulkan-cubepp

override_dh_missing:
	dh_missing --fail-missing

override_dh_clean:
	dh_clean
	rm -rf scripts/__pycache__

## vulkan-tools 1.1.97+dfsg1

=== debian/changelog ===
vulkan-tools (1.1.97+dfsg1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 23 Jan 2019 14:23:59 +0200

vulkan-tools (1.1.97+dfsg1-1) experimental; urgency=medium

  * New upstream version.
  * watch: Updated for new tag naming.
  * Use upstream names for vkcube*.
  * control: Fix a typo.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Sun, 13 Jan 2019 17:47:25 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: vulkan-tools
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.1.82.0),
+ libvulkan-dev (>= 1.1.97),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,
@@ -23,9 +22,9 @@
 Depends: ${shlibs:Depends}, ${misc:Depends},
  libvulkan1,
 Breaks: vulkan-sdk-runtime,
- vulkan-utils (<< 1.1.82.0+dfsg1-0ubuntu1),
+ vulkan-utils (<< 1.1.82.0+dfsg1-1),
 Replaces: vulkan-sdk-runtime,
- vulkan-utils (<< 1.1.82.0+dfsg1-0ubuntu1),
+ vulkan-utils (<< 1.1.82.0+dfsg1-1),
 Provides:
  vulkan-utils,
 Description: Miscellaneous Vulkan utilities
@@ -37,4 +36,4 @@
 Section: oldlibs
 Depends: vulkan-tools, ${misc:Depends}
 Description: transitional package
-  This is a transitional package. It can safely be removed.
+ This is a transitional package. It can safely be removed.

=== debian/watch ===
version=3

opts="repack,uversionmangle=s/$/+dfsg1/,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/vulkan-tools-$1.tar.gz/" \
 https://github.com/KhronosGroup/Vulkan-Tools/tags (?:.*?/)v(\d[\d.]*)\.tar\.gz

## vulkan-tools 1.1.101.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.1.101.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * watch: Use proper tag names.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 07 Mar 2019 16:00:47 +0200

=== debian/watch ===
version=3

opts="repack,uversionmangle=s/$/+dfsg1/,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/vulkan-tools-$1.tar.gz/" \
 https://github.com/KhronosGroup/Vulkan-Tools/tags (?:.*?/)sdk[_-](\d[\d.]*)\.tar\.gz

## vulkan-tools 1.1.114.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.1.114.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * watch: Updated.
  * control: Bump build-dep on libvulkan-dev.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 01 Aug 2019 21:40:25 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper (>= 11),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.1.97),
+ libvulkan-dev (>= 1.1.114.0),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,

## vulkan-tools 1.1.126.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.1.126.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dependency.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 20 Nov 2019 16:11:27 +0200

vulkan-tools (1.1.121.0+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #939301)
  * control: Bump build-dep on libvulkan-dev.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 17 Sep 2019 10:51:25 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Build-Depends: debhelper (>= 11),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.1.114.0),
+ libvulkan-dev (>= 1.1.126.0),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,

## vulkan-tools 1.2.131.1+dfsg1

=== debian/changelog ===
vulkan-tools (1.2.131.1+dfsg1-1~mx19+1) mx; urgency=medium

  * Repackage of upstream release for MX 19.

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Fri, 28 Feb 2020 10:53:29 -0500

vulkan-tools (1.2.131.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dependency.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 11 Feb 2020 23:41:36 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: vulkan-tools
 Priority: optional
-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Maintainer: SwampRabbit <maintainer@mepiscommunity.org>
+XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
 Build-Depends: debhelper (>= 11),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.1.126.0),
+ libvulkan-dev (>= 1.2.131.2),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,

## vulkan-tools 1.2.135.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.2.135.0+dfsg1-1~mx19ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19 AHS.

 -- ”SwampRabbit” <swamprabbit@mxlinux.org>  Mon, 22 Jun 2020 13:20:08 -0400

vulkan-tools (1.2.135.0+dfsg1-1) unstable; urgency=medium

  * New upstream release. (LP: #1871754)
  * control: Bump policy to 4.5.0.
  * control: Use debhelper-compat, bump to 12.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 09 Apr 2020 07:54:05 +0300

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: vulkan-tools
 Priority: optional
-Maintainer: SwampRabbit <maintainer@mepiscommunity.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
 XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.2.131.2),
+ libvulkan-dev (>= 1.2.135.0),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,
  libxrandr-dev,
  python3,
-Standards-Version: 4.2.0
+Standards-Version: 4.5.0
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Tools
 Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/vulkan-tools.git

=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,11 @@
 	dh_auto_configure -- \
 	-DGLSLANG_INSTALL_DIR=/usr/bin
 
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
-
-	mv debian/tmp/usr/bin/cube debian/tmp/usr/bin/vulkan-cube
-	mv debian/tmp/usr/bin/cubepp debian/tmp/usr/bin/vulkan-cubepp
 
 override_dh_missing:
 	dh_missing --fail-missing

## vulkan-tools 1.2.141.0+dfsg1

=== debian/changelog ===
vulkan-tools (1.2.141.0+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #963297)
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 23 Jun 2020 10:40:54 +0300

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: vulkan-tools
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
-XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
 Build-Depends: debhelper-compat (= 12),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.2.135.0),
+ libvulkan-dev (>= 1.2.141.0),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,

## vulkan-tools 1.2.162.0+dfsg1

=== cube/CMakeLists.txt ===
--- 
+++ 
@@ -38,7 +38,14 @@
     elseif(UNIX AND NOT APPLE) # i.e. Linux
         execute_process(COMMAND ${PYTHON_EXECUTABLE} ${SCRIPTS_DIR}/fetch_glslangvalidator.py glslang-master-linux-Release.zip)
     endif()
-    find_program(GLSLANG_VALIDATOR NAMES ${GLSLANG_VALIDATOR_NAME} HINTS "${PROJECT_SOURCE_DIR}/glslang/bin")
+    if (WIN32)
+        set(PLATFORM_DIR "${PROJECT_SOURCE_DIR}/glslang/windows/bin")
+    elseif(APPLE)
+        set(PLATFORM_DIR "${PROJECT_SOURCE_DIR}/glslang/darwin/bin")
+    else()
+        set(PLATFORM_DIR "${PROJECT_SOURCE_DIR}/glslang/linux/bin")
+    endif()
+    find_program(GLSLANG_VALIDATOR NAMES ${GLSLANG_VALIDATOR_NAME} HINTS ${PLATFORM_DIR})
 endif()
 
 if(UNIX AND NOT APPLE) # i.e. Linux
@@ -46,7 +53,8 @@
     option(BUILD_WSI_XCB_SUPPORT "Build XCB WSI support" ON)
     option(BUILD_WSI_XLIB_SUPPORT "Build Xlib WSI support" ON)
     option(BUILD_WSI_WAYLAND_SUPPORT "Build Wayland WSI support" ON)
-    set(CUBE_WSI_SELECTION "XCB" CACHE STRING "Select WSI target for vkcube (XCB, XLIB, WAYLAND, DISPLAY)")
+    option(BUILD_WSI_DIRECTFB_SUPPORT "Build DirectFB WSI support" OFF)
+    set(CUBE_WSI_SELECTION "XCB" CACHE STRING "Select WSI target for vkcube (XCB, XLIB, WAYLAND, DIRECTFB, DISPLAY)")
 
     if(BUILD_WSI_XCB_SUPPORT)
         find_package(XCB REQUIRED)
@@ -60,12 +68,17 @@
         find_package(Wayland REQUIRED)
         include_directories(${WAYLAND_CLIENT_INCLUDE_DIR})
     endif()
+
+    if(BUILD_WSI_DIRECTFB_SUPPORT)
+        find_package(DirectFB REQUIRED)
+        include_directories(${DIRECTFB_INCLUDE_DIR})
+    endif()
 endif()
 
 if(WIN32)
     add_definitions(-DVK_USE_PLATFORM_WIN32_KHR -DWIN32_LEAN_AND_MEAN)
-    if(NOT MSVC_VERSION LESS 1900)
-        # Enable control flow guard
+    if(MSVC AND NOT MSVC_VERSION LESS 1900)
+        # If MSVC, Enable control flow guard
         message(STATUS "Building vkcube with control flow guard")
         add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/guard:cf>")
         set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /guard:cf")
@@ -101,6 +114,13 @@
         set(CUBE_INCLUDE_DIRS ${WAYLAND_CLIENT_INCLUDE_DIR} ${CUBE_INCLUDE_DIRS})
         link_libraries(${WAYLAND_CLIENT_LIBRARIES})
         add_definitions(-DVK_USE_PLATFORM_WAYLAND_KHR)
+    elseif(CUBE_WSI_SELECTION STREQUAL "DIRECTFB")
+        if(NOT BUILD_WSI_DIRECTFB_SUPPORT)
+            message(FATAL_ERROR "Selected DIRECTFB for vkcube build but not building DirectFB support")
+        endif()
+        set(CUBE_INCLUDE_DIRS ${DIRECTFB_INCLUDE_DIR} ${CUBE_INCLUDE_DIRS})
+        link_libraries(${DIRECTFB_LIBRARIES})
+        add_definitions(-DVK_USE_PLATFORM_DIRECTFB_EXT)
     elseif(CUBE_WSI_SELECTION STREQUAL "DISPLAY")
         add_definitions(-DVK_USE_PLATFORM_DISPLAY_KHR)
     else()
@@ -135,8 +155,6 @@
                            "${${configuration}}")
         endif()
     endforeach()
-
-    file(COPY cube.vcxproj.user DESTINATION ${CMAKE_BINARY_DIR}/cube)
 endif()
 
 add_custom_command(COMMENT "Compiling cube vertex shader"
@@ -174,6 +192,7 @@
                        cube.vert.inc
                        cube.frag.inc)
         target_link_libraries(vkcube Vulkan::Vulkan)
+        include(CheckLibraryExists)
         CHECK_LIBRARY_EXISTS("rt" clock_gettime "" NEED_RT)
         if (NEED_RT)
             target_link_libraries(vkcube rt)

=== vulkaninfo/CMakeLists.txt ===
--- 
+++ 
@@ -17,22 +17,6 @@
 
 # CMakeLists.txt file for building Vulkaninfo
 
-find_package(PythonInterp 3 QUIET)
-set (PYTHON_CMD ${PYTHON_EXECUTABLE})
-
-set(VKINFO_DIR ${CMAKE_CURRENT_SOURCE_DIR})
-set(KVULKANTOOLS_SCRIPTS_DIR ${CMAKE_SOURCE_DIR}/scripts)
-
-if(PYTHONINTERP_FOUND)
-    add_custom_target(generate_vulkaninfo_hpp
-        COMMAND ${PYTHON_CMD} ${KVULKANTOOLS_SCRIPTS_DIR}/kvt_genvk.py -registry ${VulkanRegistry_DIR}/vk.xml -scripts ${VulkanRegistry_DIR} vulkaninfo.hpp
-        DEPENDS ${VulkanRegistry_DIR}/vk.xml ${VulkanRegistry_DIR}/generator.py ${KVULKANTOOLS_SCRIPTS_DIR}/vulkaninfo_generator.py ${KVULKANTOOLS_SCRIPTS_DIR}/kvt_genvk.py ${VulkanRegistry_DIR}/reg.py
-        WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/vulkaninfo/generated
-        )
-    else()
-        message("WARNING: generate_vulkaninfo_hpp target requires python 3")
-endif()
-
 if(WIN32)
     add_executable(vulkaninfo vulkaninfo.cpp vulkaninfo.rc)
 elseif(APPLE)
@@ -47,31 +31,43 @@
 target_include_directories(vulkaninfo PRIVATE ${CMAKE_SOURCE_DIR}/vulkaninfo)
 target_include_directories(vulkaninfo PRIVATE ${CMAKE_SOURCE_DIR}/vulkaninfo/generated)
 
+if (NOT WIN32)
+    target_link_libraries(vulkaninfo ${CMAKE_DL_LIBS})
+endif()
+
 if(UNIX AND NOT APPLE) # i.e. Linux
     include(FindPkgConfig)
     option(BUILD_WSI_XCB_SUPPORT "Build XCB WSI support" ON)
     option(BUILD_WSI_XLIB_SUPPORT "Build Xlib WSI support" ON)
     option(BUILD_WSI_WAYLAND_SUPPORT "Build Wayland WSI support" ON)
+    option(BUILD_WSI_DIRECTFB_SUPPORT "Build DirectFB WSI support" OFF)
 
     if(BUILD_WSI_XCB_SUPPORT)
         find_package(XCB REQUIRED)
         target_include_directories(vulkaninfo PRIVATE ${XCB_INCLUDE_DIRS})
         target_link_libraries(vulkaninfo ${XCB_LIBRARIES})
-        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_XCB_KHR)
+        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_XCB_KHR -DVK_NO_PROTOTYPES)
     endif()
 
     if(BUILD_WSI_XLIB_SUPPORT)
         find_package(X11 REQUIRED)
         target_include_directories(vulkaninfo PRIVATE ${X11_INCLUDE_DIR})
         target_link_libraries(vulkaninfo ${X11_LIBRARIES})
-        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_XLIB_KHR)
+        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_XLIB_KHR -DVK_NO_PROTOTYPES)
     endif()
 
     if(BUILD_WSI_WAYLAND_SUPPORT)
         find_package(Wayland REQUIRED)
         target_include_directories(vulkaninfo PRIVATE ${WAYLAND_CLIENT_INCLUDE_DIR})
         target_link_libraries(vulkaninfo ${WAYLAND_CLIENT_LIBRARIES})
-        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_WAYLAND_KHR)
+        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_WAYLAND_KHR -DVK_NO_PROTOTYPES)
+    endif()
+
+    if(BUILD_WSI_DIRECTFB_SUPPORT)
+        find_package(DirectFB REQUIRED)
+        target_include_directories(vulkaninfo PRIVATE ${DIRECTFB_INCLUDE_DIR})
+        target_link_libraries(vulkaninfo ${DIRECTFB_LIBRARIES})
+        target_compile_definitions(vulkaninfo PRIVATE -DVK_USE_PLATFORM_DIRECTFB_EXT -DVK_NO_PROTOTYPES)
     endif()
 endif()
 
@@ -80,7 +76,7 @@
     target_link_libraries(vulkaninfo ${Vulkan_LIBRARY} "-framework AppKit -framework QuartzCore")
     target_include_directories(vulkaninfo PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/macOS/vulkaninfo ${VulkanHeaders_INCLUDE_DIR})
 else()
-    target_link_libraries(vulkaninfo Vulkan::Vulkan)
+    target_include_directories(vulkaninfo PRIVATE ${VulkanHeaders_INCLUDE_DIR})
 endif()
 
 # Create vulkaninfo application bundle for MacOS
@@ -89,9 +85,9 @@
 endif()
 
 if(WIN32)
-    target_compile_definitions(vulkaninfo PUBLIC -DVK_USE_PLATFORM_WIN32_KHR -DWIN32_LEAN_AND_MEAN -D_CRT_SECURE_NO_WARNINGS)
-    if(NOT MSVC_VERSION LESS 1900)
-        # Enable control flow guard
+    target_compile_definitions(vulkaninfo PUBLIC -DVK_USE_PLATFORM_WIN32_KHR -DWIN32_LEAN_AND_MEAN -D_CRT_SECURE_NO_WARNINGS -DVK_NO_PROTOTYPES)
+    if(MSVC AND NOT MSVC_VERSION LESS 1900)
+        # If MSVC, Enable control flow guard
         message(STATUS "Building vulkaninfo with control flow guard")
         add_compile_options("$<$<CXX_COMPILER_ID:MSVC>:/guard:cf>")
         set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /guard:cf")
@@ -117,8 +113,6 @@
                            "${${configuration}}")
         endif()
     endforeach()
-
-    file(COPY vulkaninfo.vcxproj.user DESTINATION ${CMAKE_BINARY_DIR}/vulkaninfo)
 elseif(APPLE)
     add_definitions(-DVK_USE_PLATFORM_MACOS_MVK -DVK_USE_PLATFORM_METAL_EXT)
 endif()

=== debian/changelog ===
vulkan-tools (1.2.162.0+dfsg1-1~mx19ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-19 AHS.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 25 Jan 2021 18:19:26 -0500

vulkan-tools (1.2.162.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dependency.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 07 Jan 2021 10:50:27 +0200

vulkan-tools (1.2.154.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 09 Oct 2020 10:02:45 +0300

vulkan-tools (1.2.148.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.
  * Drop vulkan-utils transitional package.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 15 Sep 2020 18:15:54 +0300

=== debian/control ===
Source: vulkan-tools
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Build-Depends: debhelper-compat (= 12),
 cmake,
 glslang-tools,
 libvulkan-dev (>= 1.2.162.0),
 libwayland-dev,
 libx11-dev,
 libxcb1-dev,
 libxrandr-dev,
 python3,
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/KhronosGroup/Vulkan-Tools
Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/vulkan-tools.git
Vcs-Browser: https://salsa.debian.org/xorg-team/vulkan/vulkan-tools

Package: vulkan-tools
Architecture: linux-any
Section: graphics
Depends: ${shlibs:Depends}, ${misc:Depends},
 libvulkan1,
Breaks: vulkan-sdk-runtime,
Replaces: vulkan-sdk-runtime,
Description: Miscellaneous Vulkan utilities
 This package provides utilities for Vulkan, including vulkaninfo.

## vulkan-tools 1.2.189.0%2Bdfsg1

=== debian/changelog ===
vulkan-tools (1.2.189.0+dfsg1-1~mx21ahs+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21 AHS.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sun, 12 Sep 2021 23:53:20 -0400

vulkan-tools (1.2.189.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 08 Sep 2021 16:22:11 +0300

vulkan-tools (1.2.182.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 01 Sep 2021 16:13:10 +0300

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper-compat (= 12),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.2.162.0),
+ libvulkan-dev (>= 1.2.189.0),
  libwayland-dev,
  libx11-dev,
  libxcb1-dev,

=== debian/rules ===
--- 
+++ 
@@ -7,12 +7,12 @@
 %:
 	dh $@ --builddirectory=build/
 
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
+
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	-DGLSLANG_INSTALL_DIR=/usr/bin
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym
 
 override_dh_auto_install:
 	dh_auto_install --destdir=debian/tmp
